import 'package:flutter/material.dart';

class LoadingWrapper extends StatelessWidget {
  final Widget child;
  final ValueNotifier<bool> isLoading;
  final Widget loadingWidget;

  const LoadingWrapper({Key key, this.isLoading, this.child, this.loadingWidget}) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return Stack(
      children: <Widget>[
        child,
        ValueListenableBuilder<bool>(
            valueListenable: isLoading,
            builder: (_, value, __) => value ? loadingWidget : SizedBox.shrink())
      ],
    );
  }
}
